//+------------------------------------------------------------------+
//|                                                VininI_WPR_FO.mq5 |
//|                                Copyright  2009, Victor Nicolaev |
//|                                            e-mail: vinin@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Victor Nicolaev"
#property link      "e-mail: vinin@mail.ru"
//----   
#property version   "1.00"
//----     
#property indicator_separate_window
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   1
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----   
#property indicator_type1 DRAW_COLOR_ARROW
//----     Blue,Lime,Red
#property indicator_color1 Blue,Lime,Red
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1  "VininI WPR FO"
//+-----------------------------------+
//|      |
//+-----------------------------------+
#property indicator_minimum -1.25
#property indicator_maximum  1.25
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0 //        
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum ENUM_IND_STYLE  //   
  {
   COLOR_LINE = DRAW_COLOR_LINE,          //  
   COLOR_HISTOGRAM=DRAW_COLOR_HISTOGRAM,  //  
   COLOR_ARROW=DRAW_COLOR_ARROW           //  
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int  WPR_Period=5;                   //  WPR
input int  MA_Period =9;                   //  
input ENUM_MA_METHOD  MA_Method_=MODE_EMA; //  
input double HighLevel  =+0.5;
input double MiddleLevel= 0.0;
input double LowLevel   =-0.5;
input ENUM_IND_STYLE Style=COLOR_HISTOGRAM; //   
//+----------------------------------------------+
//----   ,   
//----      
double ColorBuffer[],ExtLineBuffer[];
//----      
int WPR_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//|   CMoving_Average                                  | 
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   min_rates_total=WPR_Period+MA_Period+1;
//----    WPR
   WPR_Handle=iWPR(NULL,0,WPR_Period);
   if(WPR_Handle==INVALID_HANDLE) Print("      WPR");

//----    ExtLineBuffer[]   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,Style);
//----       
   ArraySetAsSeries(ExtLineBuffer,true);

//----    ColorBuffer[]       
   SetIndexBuffer(1,ColorBuffer,INDICATOR_COLOR_INDEX);
//----       1  min_rates_total
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(ColorBuffer,true);

//----      3   
   IndicatorSetInteger(INDICATOR_LEVELS,3);
//----       
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,HighLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,MiddleLevel);
   IndicatorSetDouble(INDICATOR_LEVELVALUE,2,LowLevel);
//----             
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,0,Magenta);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,1,Gray);
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,2,Magenta);
//----       -  
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,0,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,1,STYLE_DASHDOTDOT);
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,2,STYLE_DASHDOTDOT);

//----      
   string shortname;
   StringConcatenate(shortname,"VininI WPR FO(",WPR_Period,", ",MA_Period,", ",EnumToString(MA_Method_),")");
//----           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//----     
// IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(WPR_Handle)<rates_total || rates_total<min_rates_total) return(RESET);

//----    
   int to_copy,limit,bar,maxbar;
   double WPR[],velue,ma,expma,fish;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-1-WPR_Period;                   //      
   else limit=rates_total-prev_calculated;              //      

//----    maxbar   MASeries()
   maxbar=rates_total-1-WPR_Period;

//----      
   to_copy=limit+1;

//----       WPR[]
   if(CopyBuffer(WPR_Handle,0,0,to_copy,WPR)<=0) return(RESET);

//----    ,     
   ArraySetAsSeries(WPR,true);

//----    CMoving_Average   SmoothAlgorithms.mqh
   static CMoving_Average MA;

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      velue=0.1*(WPR[bar]+50);
      ma=MA.MASeries(maxbar,prev_calculated,rates_total,MA_Period,MA_Method_,velue,bar,true);

      if(bar<maxbar)
        {
         expma=MathExp(2.0*ma);
         fish=(expma-1.0)/(expma+1.0);
        }
      else fish=EMPTY_VALUE;

      ExtLineBuffer[bar]=fish;
      ColorBuffer[bar]=0;
      if(ma>HighLevel&&ma!=EMPTY_VALUE) ColorBuffer[bar]=1;
      if(ma<LowLevel &&ma!=EMPTY_VALUE) ColorBuffer[bar]=2;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
